Index: branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/cfg/X64_ADA.cfg
===================================================================
--- branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/cfg/X64_ADA.cfg	(revision 5424)
+++ branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/cfg/X64_ADA.cfg	(revision 5432)
@@ -1,5 +1,9 @@
-# 
+# Ada super-computer configuration
+
+# Available softwares:
+CDO=cdo
 COMPILER=ifort
-MPI_NAME=intel
+MPI=intel
+NETCDF=netcdf
 
 # Job commands: LoadLeveler
@@ -9,9 +13,8 @@
 JOB_DELE=llcancel                          
 
-# Directories ($HOME/$WORKDIR/$COMMONDIR/$TMPDIR/ergon)
-DIR_WORK=$WORKDIR
-DIR_SCRA=$TMPDIR/trusting
-DIR_STOR=trusting_sav
+# Compiling & computing settings
+[ -z "$NPROC"       ] && NPROC=32
+[ -z "${TIME_LIMI}" ] && TIME_LIMI=10800 # 3h
 
-# Loading environment architecture
-. ${DIR_XIOS}/arch/arch-${ARCH}.env
+# Architecture environment (be careful with compliance with XIOS)
+ARCH_ENV=${DIR_XIOS}/arch/arch-${CFG_ARCH}.env
Index: branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/trusting.sh
===================================================================
--- branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/trusting.sh	(revision 5424)
+++ branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/trusting.sh	(revision 5432)
@@ -105,5 +105,5 @@
 [ $? -ne 0 ] && get_out
 [ $( find . -name '*.gz' -print -quit ) ] && gunzip *.gz
-
+exit 0
 
 # Job submission & computing
Index: branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/trusting_func.sh
===================================================================
--- branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/trusting_func.sh	(revision 5424)
+++ branches/2015/dev_r5092_CNRS_SETTE/NEMOGCM/TRUST/trusting_func.sh	(revision 5432)
@@ -32,19 +32,23 @@
 
     if [ $( find ${TEST_DIR} -name "*${last_time_step}_restart*.nc" -print -quit ) ]; then
-	file_base=$( find ${TEST_DIR} -name "*${last_time_step}_restart*.nc" -print -quit | \
-	             sed "s/^\(.*\)0*$last_time_step.*/\1/"                                 )
+	basename=$( find ${TEST_DIR} -name "*${last_time_step}_restart*.nc" -print -quit \
+	             | sed "s/^\(.*\)$last_time_step\_.*/\1$last_time_step/"               )
 
-	for file in restart restart_ice restart_trc; do
-	    printf "${TEST_DIR}/*${last_time_step}_${file}*.nc: "
+	for comp in restart restart_ice restart_trc; do
+	    printf "${TEST_DIR}/${basename}_${comp}*.nc: "
 
-	    nb_dom=$( find ${TEST_DIR} -name "*${last_time_step}_${file}_[0-9]*.nc" | wc -l | awk '{print $1}' )
+	    nb_dom=$( find ${TEST_DIR} -name "${basename}_${comp}_[0-9]*.nc" | wc -l | awk '{print $1}' )
 	    if [ ${nb_dom} -gt 1 ]; then
-		${NEMO_TRBD}/rebuild_nemo -t $NPROC ${file_base}${last_time_step}_$file ${nb_dom} >/dev/null
+		${NEMO_TRBD}/rebuild_nemo -t $NPROC ${basename}_$comp ${nb_dom} >/dev/null
 	    fi
 
-#	    result=$( diff_nc ${TEST_DIR}/*${last_time_step}_$file.nc ${REFE_DIR}/*${last_time_step}_$file.nc )
-	    result=$( diff_nc ${file_base}${last_time_step}_$file.nc ${REFE_DIR}/*${last_time_step}_$file.nc )
-	    printf "$CDO diffv $result\n"
-#	    \rm *${last_time_step}_${file}_[0-9]*.nc
+	    cmp ${TEST_DIR}/${basename}_$comp.nc ${REFE_DIR}/${basename}_$comp.nc
+	    if [ $? -ne 0 ]; then
+		result=$( diff_nc ${TEST_DIR}/${basename}_$comp.nc ${REFE_DIR}/${basename}_$comp.nc )
+		printf "$CDO diffv $result\n"
+	    else
+		printf "identical\n"
+	    fi
+#	    \rm *${last_time_step}_${comp}_[0-9]*.nc
 	done
 
@@ -56,7 +60,7 @@
 get_soft_rel() {
     for rel in $CDO $COMPILER $MPI $NETCDF; do
-                                arch_rel=$( echo $LOADEDMODULES | sed "s#.*$rel/\([^:]*\).*#\1#" )
-	[ -z "${arch_rel}" ] && arch_rel=$( echo $PATH          | sed "s#.*$rel/\([^/]*\).*#\1#" )
-	[ $( echo $rel | grep $COMPILER ) ] && arch_rel=$( $rel --version | grep -m1 -o ' [0-9.]* ' )
+                                 arch_rel=$( echo $LOADEDMODULES | sed "s#.*$rel/\([^:]*\).*#\1#" )
+	[ -z "${arch_rel}"  ] && arch_rel=$( echo $PATH          | sed "s#.*$rel/\([^/]*\).*#\1#" )
+	[ $rel == $COMPILER ] && arch_rel=$( $rel --version | grep -m1 -o ' [0-9.]* ' )
 	echo $rel ${arch_rel} >> model.log
     done
@@ -71,5 +75,5 @@
 	[ $dir == ${DIR_XIOS} ] && echo 'XIOS '$( svn info $dir | awk '(NR == 9) {print $NF}' ) >> model.log && continue
 	${SVN_CMD} $dir
-	rev_loc=$( svn info $dir | awk '(NR == 9) {print $NF}' )
+	rev_loc=$( svn info $dir | awk '(NR == 5) {print $NF}' )
 	(( ${rev_loc} >= $rev )) && rev=${rev_loc}
     done