Index: /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/TScst-current-temp_1S1N.jnl
===================================================================
--- /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/TScst-current-temp_1S1N.jnl	(revision 5435)
+++ /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/TScst-current-temp_1S1N.jnl	(revision 5435)
@@ -0,0 +1,52 @@
+ ! NOAA/PMEL TMAP
+ ! FERRET v6.85  
+ ! Linux 2.6.32-358.23.2.el6.x86_64 64-bit - 11/12/13
+ ! 24-Feb-15 14:35     
+
+!start script :
+! plot over all basin from 0 to 1000 m in z
+! of velocities U and temperature T
+!
+!USE grid-U files
+!
+palette blue_darkred
+!dataset=1
+use "bx025_TScst_5d_00010101_00020520_grid_U.nc"
+set w 1
+!  to have z down
+def axis/from_data/depth/name=z1 z[g=uo]
+!  to have longitude instead of index points
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+!  to have latitude instead of index points
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let uo_mod = uo[gx=xaxis@asn,gy=yaxis@asn]
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=1/title="TScst-vel-U SURFACE at 1 timestep"  uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="TScst-velU-surf-initial.gif"
+set w 2
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=100/title="TScst-vel-U SURFACE after 500 days" uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="TScst-velU-surf-at500days.gif"
+set w 3
+fill/lev=(-INF)(-1,1,0.1)(INF)/title="TScst-vel-U prof between 1S and 1N at 1 timestep"  uo_mod[y=1S:1N@ave,z=1:1000,l=1,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="TScst-velU-prof-1S1N-initial.gif"
+set w 4
+fill/lev=(-INF)(-1,1,0.1)(INF)/title="TScst-vel-U prof between 1S and 1N after 500 days" uo_mod[y=1S:1N@ave,z=1:1000,l=100,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="TScst-velU-prof-1S1N-at500days.gif"
+!dataset=2
+use "bx025_TScst_5d_00010101_00020520_grid_T.nc"
+def axis/from_data/depth/name=z1 z[g=thetao]
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let thetao_mod = thetao[gx=xaxis@asn,gy=yaxis@asn]
+set w 5
+fill/lev=(-INF)(3,23,1)(INF)/title="TScst-temp-T between 1S and 1N at 1 timestep" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=1,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="TScst-tempT-1S1N-initial.gif"
+set w 6
+fill/lev=(-INF)(3,23,1)(INF)/title="TScst-temp-T between 1S and 1N after 500 days N" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=100,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="TScst-tempT-1S1N-at500days.gif"
+!
Index: anches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/current-temp_1S1N.jnl
===================================================================
--- /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/current-temp_1S1N.jnl	(revision 5434)
+++ 	(revision )
@@ -1,54 +1,0 @@
- ! NOAA/PMEL TMAP
- ! FERRET v6.85  
- ! Linux 2.6.32-358.23.2.el6.x86_64 64-bit - 11/12/13
- ! 24-Feb-15 14:35     
-
-!start script :
-! plot over all basin from 0 to 1000 m in z
-! of velocities U and temperature T
-!
-!USE grid-U files
-!
-palette blue_darkred
-!dataset=1
-use "bx025_tprof_1d_00010101_00020520_grid_U.nc"
-set re/z=1          
-set w 1
-fill/lev=(-INF)(-0.2,0.2,0.01)(INF)/title="vel-U" uo[x=1:721,y=1:241,l=1,d=1]
-! "NAME OF OUTPUT FILE"
-FRAME/FILE="velU-at-1day.gif"
-set w 2
-fill/lev=(-INF)(-0.2,0.2,0.01)(INF)/title="vel-U" uo[x=1:721,y=1:241,l=100,d=1]
-! "NAME OF OUTPUT FILE"
-FRAME/FILE="velU-at-500days.gif"
-!!!!!!!!set w 3
-!!!!!!!fill/lev=(-INF)(-0.2,0.2,0.01)(INF)/title="vel-U" uo[x=1:721,y=1:241,l=@ave,d=1]
-! "NAME OF OUTPUT FILE"
-!!!!!!!FRAME/FILE="velU-average-1_500days.gif"
-!
-set w 3
-def axis/from_data/depth/name=z1 z[g=uo]
-ca re
-! method with indix, from list i see index corresponding to -1, 1
-!fill/lev=(-INF)(-0.0002,0.0002,0.00001)(INF)/title="vel-U" uo[gz=z1@asn,j=117:125@ave,l=100,d=1]
-define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
-define axis/y/from/units=degrees yaxis=nav_lat[i=1]
-let uo_mod = uo[gx=xaxis@asn,gy=yaxis@asn]
-shade/k=1/l=1/title="vel-U between 1south 1 north at 1 timestep"  uo_mod
-! "NAME OF OUTPUT FILE"
-FRAME /FILE="velU-1S1N-initial.gif"
-set w 4
-shade/k=1/l=100/title="vel-U between 1south 1 north after 500 days" uo_mod
-! "NAME OF OUTPUT FILE"
-FRAME /FILE="velU-1S1N-at500days.gif"
-!dataset=2
-ca re
-use "bx025_tprof_1d_00010101_00020520_grid_T.nc"
-def axis/from_data/depth/name=z1 z[g=thetao]
-set re/z=0:1000
-!set memory/size=20000000
-set w 5
-fill/lev=(-INF)(3,23,1)(INF)/title="temp-T" thetao[gz=z1@asn,y=@ave,l=100,d=2]
-! "NAME OF OUTPUT FILE"
-FRAME /FILE="tempT-1S1N.gif"
-!
Index: /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/e1e2cst-current-temp_1S1N.jnl
===================================================================
--- /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/e1e2cst-current-temp_1S1N.jnl	(revision 5435)
+++ /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/e1e2cst-current-temp_1S1N.jnl	(revision 5435)
@@ -0,0 +1,53 @@
+ ! NOAA/PMEL TMAP
+ ! FERRET v6.85  
+ ! Linux 2.6.32-358.23.2.el6.x86_64 64-bit - 11/12/13
+ ! 24-Feb-15 14:35     
+
+!start script :
+! plot over all basin from 0 to 1000 m in z
+! of velocities U and temperature T
+!
+!USE grid-U files
+!
+palette blue_darkred
+!dataset=1
+use "bx025_TScst-e1e2cst_5d_00010101_00020520_grid_U.nc"
+set w 1
+!  to have z down
+def axis/from_data/depth/name=z1 z[g=uo]
+!  to have longitude instead of index points
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+!  to have latitude instead of index points
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let uo_mod = uo[gx=xaxis@asn,gy=yaxis@asn]
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=1/title="e1e2cst-vel-U SURFACE at 1 timestep"  uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="e1e2cst-velU-surf-initial.gif"
+set w 2
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=100/title="e1e2cst-vel-U SURFACE after 500 days" uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="e1e2cst-velU-surf-at500days.gif"
+set re/z=0:1000
+set w 3
+fill/lev=(-INF)(-1,1,0.1)(INF)/l=1/title="e1e2cst-vel-U prof between 1S and 1N at 1 timestep"  uo_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=1,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="e1e2cst-velU-prof-1S1N-initial.gif"
+set w 4
+fill/lev=(-INF)(-1,1,0.1)(INF)/l=100/title="e1e2cst-vel-U prof between 1S and 1N after 500 days" uo_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=100,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="e1e2cst-velU-prof-1S1N-at500days.gif"
+!dataset=2
+use "bx025_TScst-e1e2cst_5d_00010101_00020520_grid_T.nc"
+def axis/from_data/depth/name=z1 z[g=thetao]
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let thetao_mod = thetao[gx=xaxis@asn,gy=yaxis@asn]
+set w 5
+fill/lev=(-INF)(3,23,1)(INF)/title="e1e2cst-temp-T between 1S and 1N at 1 timestep" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=1,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="e1e2cst-tempT-1S1N-initial.gif"
+set w 6
+fill/lev=(-INF)(3,23,1)(INF)/title="e1e2cst-temp-T between 1S and 1N after 500 days N" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=100,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="e1e2cst-tempT-1S1N-at500days.gif"
+!
Index: /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/gphi0-current-temp_1S1N.jnl
===================================================================
--- /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/gphi0-current-temp_1S1N.jnl	(revision 5435)
+++ /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/gphi0-current-temp_1S1N.jnl	(revision 5435)
@@ -0,0 +1,44 @@
+ ! NOAA/PMEL TMAP
+ ! FERRET v6.85  
+ ! Linux 2.6.32-358.23.2.el6.x86_64 64-bit - 11/12/13
+ ! 24-Feb-15 14:35     
+
+!start script :
+! plot over all basin from 0 to 1000 m in z
+! of velocities U and temperature T
+!
+!USE grid-U files
+!
+palette blue_darkred
+!dataset=1
+use "bx025_TScst_cst_gphi0_5d_00010101_00020520_grid_U.nc"
+set w 1
+!  to have z down
+def axis/from_data/depth/name=z1 z[g=uo]
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=1/title="vel-U SURFACE at 1 timestep"  uo[gz=z1@asn]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="gphi0-velU-surf-initial.gif"
+set w 2
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=100/title="gphi0-vel-U SURFACE after 500 days" uo[gz=z1@asn]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="gphi0-velU-surf-at500days.gif"
+set w 3
+fill/lev=(-INF)(-1,1,0.1)(INF)/l=1/title="gphi0-vel-U prof between 1S and 1N at 1 timestep"  uo[j=117:125@ave,z=1:1000,l=1,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="gphi0-velU-prof-1S1N-initial.gif"
+set w 4
+fill/lev=(-INF)(-1,1,0.1)(INF)/l=100/title="gphi0-vel-U prof between 1S and 1N after 500 days" uo[j=117:125@ave,z=1:1000,l=100,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="gphi0-velU-prof-1S1N-at500days.gif"
+!dataset=2
+use "bx025_TScst_cst_gphi0_5d_00010101_00020520_grid_T.nc"
+def axis/from_data/depth/name=z1 z[g=thetao]
+set w 5
+fill/lev=(-INF)(3,23,1)(INF)/title="gphi0-temp-T between 1S and 1N initial" thetao[gz=z1@asn,j=117:125@ave,z=1:1000,l=1,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="gphi0-tempT-1S1N-initial.gif"
+set w 6
+fill/lev=(-INF)(3,23,1)(INF)/title="gphi0-temp-T between 1S and 1N after 500 days N" thetao[gz=z1@asn,j=117:125@ave,z=1:1000,l=100,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="gphi0-tempT-1S1N-at500days.gif"
+!
Index: /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/kelv-current-temp_1S1N.jnl
===================================================================
--- /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/kelv-current-temp_1S1N.jnl	(revision 5435)
+++ /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/kelv-current-temp_1S1N.jnl	(revision 5435)
@@ -0,0 +1,53 @@
+ ! NOAA/PMEL TMAP
+ ! FERRET v6.85  
+ ! Linux 2.6.32-358.23.2.el6.x86_64 64-bit - 11/12/13
+ ! 24-Feb-15 14:35     
+
+!start script :
+! plot over all basin from 0 to 1000 m in z
+! of velocities U and temperature T
+!
+!USE grid-U files
+!
+palette blue_darkred
+!dataset=1
+use "bx025_kelvin_1d_00010911_00020520_grid_U.nc"
+set w 1
+!  to have z down
+def axis/from_data/depth/name=z1 z[g=uo]
+!  to have longitude instead of index points
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+!  to have latitude instead of index points
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let uo_mod = uo[gx=xaxis@asn,gy=yaxis@asn]
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=1/title="kelv-vel-U SURFACE at 1 timestep"  uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="Kelv-velU-initial.gif"
+set w 2
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=250/title="kelv-vel-U between 1S and 1N after 500 days" uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="Kelv-velU-at500days.gif"
+set re/z=0:1000
+set w 3
+fill/lev=(-INF)(-1,1,0.1)(INF)/title="kelv-vel-U prof between 1S and 1N at 1 timestep"  uo_mod[gz=z1@asn,gx=xaxis@asn,y=1S:1N@ave,z=1:1000,l=1,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="Kelv-velU-prof-1S1N-initial.gif"
+set w 4
+fill/lev=(-INF)(-1,1,0.1)(INF)/title="kelv-vel-U prof between 1S and 1N after 500 days" uo_mod[gz=z1@asn,gx=xaxis@asn,y=1S:1N@ave,z=1:1000,l=250,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="Kelv-velU-prof-1S1N-at500days.gif"
+!dataset=2
+use "bx025_kelvin_1d_00010911_00020520_grid_T.nc"
+def axis/from_data/depth/name=z1 z[g=thetao]
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let thetao_mod = thetao[gx=xaxis@asn,gy=yaxis@asn]
+set w 5
+fill/lev=(-INF)(3,23,1)(INF)/title="kelv-temp-T between 1S and 1N at 1 timestep" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=1,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="Kelv-tempT-1S1N-initial.gif"
+set w 6
+fill/lev=(-INF)(3,23,1)(INF)/title="kelv-temp-T between 1S and 1N after 500 days N" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=250,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="Kelv-tempT-1S1N-at500days.gif"
+!
Index: /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/tprof-current-temp_1S1N.jnl
===================================================================
--- /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/tprof-current-temp_1S1N.jnl	(revision 5435)
+++ /branches/2015/dev_r5102_CNRS11_TestCase/NEMOGCM/TOOLS/TEST_CASES/CREATE_PLOTS/tprof-current-temp_1S1N.jnl	(revision 5435)
@@ -0,0 +1,52 @@
+ ! NOAA/PMEL TMAP
+ ! FERRET v6.85  
+ ! Linux 2.6.32-358.23.2.el6.x86_64 64-bit - 11/12/13
+ ! 24-Feb-15 14:35     
+
+!start script :
+! plot over all basin from 0 to 1000 m in z
+! of velocities U and temperature T
+!
+!USE grid-U files
+!
+palette blue_darkred
+!dataset=1
+use "bx025_tprof_1d_00010101_00020520_grid_U.nc"
+set w 1
+!  to have z down
+def axis/from_data/depth/name=z1 z[g=uo]
+!  to have longitude instead of index points
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+!  to have latitude instead of index points
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let uo_mod = uo[gx=xaxis@asn,gy=yaxis@asn]
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=1/title="tprof-vel-U SURFACE at 1 timestep"  uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="tprof-velU-surf-1S1N-initial.gif"
+set w 2
+fill/lev=(-INF)(-1,1,0.1)(INF)/k=1/l=500/title="tprof-vel-U SURFACE after 500 days" uo_mod
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="tprof-velU-surf-1S1N-at500days.gif"
+set w 3
+fill/lev=(-INF)(-1,1,0.1)(INF)/title="tprof-vel-U prof between 1S and 1N at 1 timestep"  uo_mod[gz=z1@asn,gx=xaxis@asn,y=1S:1N@ave,z=1:1000,l=1,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="tprof-velU-prof-1S1N-initial.gif"
+set w 4
+fill/lev=(-INF)(-1,1,0.1)(INF)/title="tprof-vel-U prof between 1S and 1N after 500 days" uo_mod[gz=z1@asn,gx=xaxis@asn,y=1S:1N@ave,z=1:1000,l=500,d=1]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="tprof-velU-prof-1S1N-at500days.gif"
+!dataset=2
+use "bx025_tprof_1d_00010101_00020520_grid_T.nc"
+def axis/from_data/depth/name=z1 z[g=thetao]
+define axis/x/from/modulo/units=degrees xaxis=nav_lon[j=1]
+define axis/y/from/units=degrees yaxis=nav_lat[i=1]
+let thetao_mod = thetao[gx=xaxis@asn,gy=yaxis@asn]
+set w 5
+fill/lev=(-INF)(3,23,1)(INF)/title="tprof-temp-T between 1S and 1N after 500 days N" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=1,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="tprof-tempT-1S1N-initial.gif"
+set w 6
+fill/lev=(-INF)(3,23,1)(INF)/title="tprof-temp-T between 1S and 1N after 500 days N" thetao_mod[gz=z1@asn,y=1S:1N@ave,z=1:1000,l=500,d=2]
+! "NAME OF OUTPUT FILE"
+FRAME /FILE="tprof-tempT-1S1N-at500days.gif"
+!